package com.nisum.webfluxmongodbordermanagement.mongodbcontroller;

import com.nisum.webfluxmongodbordermanagement.entity.User;
import com.nisum.webfluxmongodbordermanagement.repository.UserRepository;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.data.mongo.DataMongoTest;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.test.context.junit.jupiter.SpringExtension;
import reactor.core.publisher.Flux;
import reactor.test.StepVerifier;

import java.io.IOException;
@DataMongoTest
@ExtendWith(SpringExtension.class)
public class UserControllerTest {

        // private static final String CONNECTION_STRING = "mongodb://%s:%d";
        static {
            System.setProperty("spring.mongodb.embedded.version","5.0.0");
        }


        // private WebTestClient webTestClient=WebTestClient.bindToServer().build();

        //private MongoTemplate mongoTemplate;

        @Autowired
        MongoTemplate mongoTemplate;
        @Autowired
        UserRepository userRepository;

        @BeforeEach
        public void setup() throws IOException {

//            mongoTemplate.getCollection("user");
//            //mongoTemplate.insert(new Order("6479de74df9120c3dc8ed1a5", "101", "01", "sama927365","oppo099876","success"));
//            mongoTemplate.insert(new User("2356781", "01", "samasarika","sama@123456","1"));

        }


        @Test
        public void testGetUsers(@Autowired MongoTemplate mongoTemplate) {
            mongoTemplate.getCollection("user");
            //mongoTemplate.insert(new Order("6479de74df9120c3dc8ed1a5", "101", "01", "sama927365","oppo099876","success"));
            mongoTemplate.insert(new User("2356781", "01", "samasarika","sama@123456","1"));

            Flux<User> result = userRepository.findAll();

            StepVerifier.create(result)
                    // .expectNextMatches(order -> order.getOrderId().equals("101"))
                    .expectNextMatches(user -> user.getUserId().equals("01"))
                    .expectComplete()
                    .verify();



        }
}
